;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: COUNTER_BT.inc
;;   Version: 2.60, Updated on 2013/5/19 at 10:42:36
;;  Generated by PSoC Designer 5.4.2946
;;
;;  DESCRIPTION: Assembler declarations for the Counter8 user module interface
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for COUNTER_BT API's.
;--------------------------------------------------

COUNTER_BT_CONTROL_REG_START_BIT:          equ 0x01    ; Control register start bit
COUNTER_BT_INT_REG:                        equ 0x0df
COUNTER_BT_INT_MASK:                       equ 0x02


;--------------------------------------------------
; Constants for COUNTER_BT user defined values
;--------------------------------------------------

COUNTER_BT_PERIOD:                         equ 0x7c
COUNTER_BT_COMPARE_VALUE:                  equ 0x3e


;--------------------------------------------------
; Register Address Constants for COUNTER_BT
;--------------------------------------------------

COUNTER_BT_COUNTER_REG:                equ 0x44   ; DR0 Counter register
COUNTER_BT_PERIOD_REG:                 equ 0x45   ; DR1 Period register
COUNTER_BT_COMPARE_REG:                equ 0x46   ; DR2 CompareValue register
COUNTER_BT_CONTROL_REG:                equ 0x47   ; Control register
COUNTER_BT_FUNC_REG:                   equ 0x44   ; Function register
COUNTER_BT_INPUT_REG:                  equ 0x45   ; Input register
COUNTER_BT_OUTPUT_REG:                 equ 0x46   ; Output register


;--------------------------------------------------
; COUNTER_BT Macro 'Functions'
;--------------------------------------------------

   macro COUNTER_BT_Start_M
   or    reg[COUNTER_BT_CONTROL_REG],  COUNTER_BT_CONTROL_REG_START_BIT
   endm

   macro COUNTER_BT_Stop_M
   and   reg[COUNTER_BT_CONTROL_REG], ~COUNTER_BT_CONTROL_REG_START_BIT
   endm

   macro COUNTER_BT_EnableInt_M
   M8C_EnableIntMask COUNTER_BT_INT_REG, COUNTER_BT_INT_MASK
   endm

   macro COUNTER_BT_DisableInt_M
   M8C_DisableIntMask COUNTER_BT_INT_REG, COUNTER_BT_INT_MASK
   endm


; end of file COUNTER_BT.inc
