//*****************************************************************************
//*****************************************************************************
//  FILENAME: COUNTER_RF.h
//   Version: 2.60, Updated on 2013/5/19 at 10:42:36
//  Generated by PSoC Designer 5.4.2946
//
//  DESCRIPTION: Counter8 User Module C Language interface file
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef COUNTER_RF_INCLUDE
#define COUNTER_RF_INCLUDE

#include <m8c.h>

#pragma fastcall16 COUNTER_RF_EnableInt
#pragma fastcall16 COUNTER_RF_DisableInt
#pragma fastcall16 COUNTER_RF_Start
#pragma fastcall16 COUNTER_RF_Stop
#pragma fastcall16 COUNTER_RF_bReadCounter              // Read  DR0
#pragma fastcall16 COUNTER_RF_WritePeriod               // Write DR1
#pragma fastcall16 COUNTER_RF_bReadCompareValue         // Read  DR2
#pragma fastcall16 COUNTER_RF_WriteCompareValue         // Write DR2

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 bCOUNTER_RF_ReadCounter              // Read  DR0 (Deprecated)
#pragma fastcall16 bCOUNTER_RF_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the COUNTER_RF API.
//-------------------------------------------------

extern void COUNTER_RF_EnableInt(void);                           // Proxy Class 1
extern void COUNTER_RF_DisableInt(void);                          // Proxy Class 1
extern void COUNTER_RF_Start(void);                               // Proxy Class 1
extern void COUNTER_RF_Stop(void);                                // Proxy Class 1
extern BYTE COUNTER_RF_bReadCounter(void);                        // Proxy Class 1
extern void COUNTER_RF_WritePeriod(BYTE bPeriod);                 // Proxy Class 1
extern BYTE COUNTER_RF_bReadCompareValue(void);                   // Proxy Class 2
extern void COUNTER_RF_WriteCompareValue(BYTE bCompareValue);     // Proxy Class 1

// The following functions are deprecated.
// They may be omitted in future releases
//
extern BYTE bCOUNTER_RF_ReadCounter(void);            // Deprecated
extern BYTE bCOUNTER_RF_ReadCompareValue(void);       // Deprecated


//--------------------------------------------------
// Constants for COUNTER_RF API's.
//--------------------------------------------------

#define COUNTER_RF_CONTROL_REG_START_BIT       ( 0x01 )
#define COUNTER_RF_INT_REG_ADDR                ( 0x0df )
#define COUNTER_RF_INT_MASK                    ( 0x02 )


//--------------------------------------------------
// Constants for COUNTER_RF user defined values
//--------------------------------------------------

#define COUNTER_RF_PERIOD                      ( 0x7c )
#define COUNTER_RF_COMPARE_VALUE               ( 0x3e )


//-------------------------------------------------
// Register Addresses for COUNTER_RF
//-------------------------------------------------

#pragma ioport  COUNTER_RF_COUNTER_REG: 0x044              //DR0 Count register
BYTE            COUNTER_RF_COUNTER_REG;
#pragma ioport  COUNTER_RF_PERIOD_REG:  0x045              //DR1 Period register
BYTE            COUNTER_RF_PERIOD_REG;
#pragma ioport  COUNTER_RF_COMPARE_REG: 0x046              //DR2 Compare register
BYTE            COUNTER_RF_COMPARE_REG;
#pragma ioport  COUNTER_RF_CONTROL_REG: 0x047              //Control register
BYTE            COUNTER_RF_CONTROL_REG;
#pragma ioport  COUNTER_RF_FUNC_REG:    0x144              //Function register
BYTE            COUNTER_RF_FUNC_REG;
#pragma ioport  COUNTER_RF_INPUT_REG:   0x145              //Input register
BYTE            COUNTER_RF_INPUT_REG;
#pragma ioport  COUNTER_RF_OUTPUT_REG:  0x146              //Output register
BYTE            COUNTER_RF_OUTPUT_REG;
#pragma ioport  COUNTER_RF_INT_REG:       0x0df            //Interrupt Mask Register
BYTE            COUNTER_RF_INT_REG;


//-------------------------------------------------
// COUNTER_RF Macro 'Functions'
//-------------------------------------------------

#define COUNTER_RF_Start_M \
   COUNTER_RF_CONTROL_REG |=  COUNTER_RF_CONTROL_REG_START_BIT

#define COUNTER_RF_Stop_M  \
   COUNTER_RF_CONTROL_REG &= ~COUNTER_RF_CONTROL_REG_START_BIT

#define COUNTER_RF_EnableInt_M   \
   M8C_EnableIntMask(COUNTER_RF_INT_REG, COUNTER_RF_INT_MASK)

#define COUNTER_RF_DisableInt_M  \
   M8C_DisableIntMask(COUNTER_RF_INT_REG, COUNTER_RF_INT_MASK)

#endif
// end of file COUNTER_RF.h
