//*****************************************************************************
//*****************************************************************************
//  FILENAME: DelSigPlus12.h
//   Version: 1.10, Updated on 2013/5/19 at 10:43:14
//
//  DESCRIPTION:  C declarations for the DelSig User Module with a 2nd-order
//                modulator based on a type-2 dcecimator
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef DelSigPlus12_INCLUDE
#define DelSigPlus12_INCLUDE

#include <m8c.h>

#pragma fastcall16 DelSigPlus12_Start
#pragma fastcall16 DelSigPlus12_SetPower
#pragma fastcall16 DelSigPlus12_StartAD
#pragma fastcall16 DelSigPlus12_StopAD
#pragma fastcall16 DelSigPlus12_Stop
#pragma fastcall16 DelSigPlus12_fIsDataAvailable
#pragma fastcall16 DelSigPlus12_iGetData
#pragma fastcall16 DelSigPlus12_wGetData
#pragma fastcall16 DelSigPlus12_iGetDataClearFlag
#pragma fastcall16 DelSigPlus12_wGetDataClearFlag
#pragma fastcall16 DelSigPlus12_ClearFlag

//-------------------------------------------------
// Prototypes of the DelSigPlus12 API.
//-------------------------------------------------
extern void DelSigPlus12_Start(BYTE bPower);
extern void DelSigPlus12_SetPower(BYTE bPower);
extern void DelSigPlus12_StartAD(void);
extern void DelSigPlus12_StopAD(void);
extern void DelSigPlus12_Stop(void);
extern BOOL DelSigPlus12_fIsDataAvailable(void);
extern INT  DelSigPlus12_iGetData(void);
extern WORD DelSigPlus12_wGetData(void);
extern INT  DelSigPlus12_iGetDataClearFlag(void);
extern WORD DelSigPlus12_wGetDataClearFlag(void);
extern void DelSigPlus12_ClearFlag(void);

//-------------------------------------------------
// Defines for DelSigPlus12 API's.
//-------------------------------------------------
#define DelSigPlus12_OFF                   (0)
#define DelSigPlus12_LOWPOWER              (1)
#define DelSigPlus12_MEDPOWER              (2)
#define DelSigPlus12_HIGHPOWER             (3)

#define DelSigPlus12_DATA_READY_BIT        (0x10)
#define DelSigPlus12_2S_COMPLEMENT         (0)

//-------------------------------------------------
// Hardware Register Definitions
//-------------------------------------------------
#pragma ioport  DelSigPlus12_AtoD1cr0:  0x080              //Analog block 1 control register 0
BYTE            DelSigPlus12_AtoD1cr0;
#pragma ioport  DelSigPlus12_AtoD1cr1:  0x081              //Analog block 1 control register 1
BYTE            DelSigPlus12_AtoD1cr1;
#pragma ioport  DelSigPlus12_AtoD1cr2:  0x082              //Analog block 1 control register 2
BYTE            DelSigPlus12_AtoD1cr2;
#pragma ioport  DelSigPlus12_AtoD1cr3:  0x083              //Analog block 1 control register 3
BYTE            DelSigPlus12_AtoD1cr3;
#pragma ioport  DelSigPlus12_AtoD2cr0:  0x090              //Analog block 2 control register 0
BYTE            DelSigPlus12_AtoD2cr0;
#pragma ioport  DelSigPlus12_AtoD2cr1:  0x091              //Analog block 2 control register 1
BYTE            DelSigPlus12_AtoD2cr1;
#pragma ioport  DelSigPlus12_AtoD2cr2:  0x092              //Analog block 2 control register 2
BYTE            DelSigPlus12_AtoD2cr2;
#pragma ioport  DelSigPlus12_AtoD2cr3:  0x093              //Analog block 2 control register 3
BYTE            DelSigPlus12_AtoD2cr3;

#endif
// end of file DelSigPlus12.h
