;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: DelSigPlus12.inc
;;   Version: 1.10, Updated on 2013/5/19 at 10:43:14
;;
;;  DESCRIPTION: Assembler declarations for the Delta-Sigma A/D Converter
;;               with a 2nd-order modulator and based on a type 2 decimator.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"

;--------------------------------------------------
; Constants for DelSigPlus12 API's.
;--------------------------------------------------
DelSigPlus12_INT_REG:              equ  0e0h
DelSigPlus12_INT_MASK:             equ  02h    ; Interrupt mask

DelSigPlus12_OFF:                  equ  0
DelSigPlus12_LOWPOWER:             equ  1
DelSigPlus12_MEDPOWER:             equ  2
DelSigPlus12_HIGHPOWER:            equ  3

DelSigPlus12_DATA_READY_BIT:       equ  10h
DelSigPlus12_2S_COMPLEMENT:        equ  0

;--------------------------------------------------
; Register Address Constants for DelSigPlus12
;--------------------------------------------------
DelSigPlus12_AtoD1cr0:             equ 0x80    ; SC Block 1 Control Reg 0
DelSigPlus12_AtoD1cr1:             equ 0x81    ; SC Block 1 Control Reg 1
DelSigPlus12_AtoD1cr2:             equ 0x82    ; SC Block 1 Control Reg 2
DelSigPlus12_AtoD1cr3:             equ 0x83    ; SC Block 1 Control Reg 3
DelSigPlus12_AtoD2cr0:             equ 0x90    ; SC Block 2 Control Reg 0
DelSigPlus12_AtoD2cr1:             equ 0x91    ; SC Block 2 Control Reg 1
DelSigPlus12_AtoD2cr2:             equ 0x92    ; SC Block 2 Control Reg 2
DelSigPlus12_AtoD2cr3:             equ 0x93    ; SC Block 2 Control Reg 3

DelSigPlus12_DEC_DL:                         equ 0xa1                                  ; Decimator Low Data Reg
DelSigPlus12_DEC_DH:                         equ 0xa0                                  ; Decimator High Data Reg

; end of file DelSigPlus12.inc
