//*****************************************************************************
//*****************************************************************************
//  FILENAME: PWM_SPD.h
//   Version: 2.60, Updated on 2013/5/19 at 10:44:7
//  Generated by PSoC Designer 5.4.2946
//
//  DESCRIPTION: PWM8 User Module C Language interface file
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef PWM_SPD_INCLUDE
#define PWM_SPD_INCLUDE

#include <m8c.h>

#pragma fastcall16 PWM_SPD_EnableInt
#pragma fastcall16 PWM_SPD_DisableInt
#pragma fastcall16 PWM_SPD_Start
#pragma fastcall16 PWM_SPD_Stop
#pragma fastcall16 PWM_SPD_bReadCounter              // Read  DR0
#pragma fastcall16 PWM_SPD_WritePeriod               // Write DR1
#pragma fastcall16 PWM_SPD_bReadPulseWidth           // Read  DR2
#pragma fastcall16 PWM_SPD_WritePulseWidth           // Write DR2

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 bPWM_SPD_ReadCounter              // Read  DR0 (Deprecated)
#pragma fastcall16 bPWM_SPD_ReadPulseWidth           // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the PWM_SPD API.
//-------------------------------------------------

extern void PWM_SPD_EnableInt(void);                        // Proxy Class 1
extern void PWM_SPD_DisableInt(void);                       // Proxy Class 1
extern void PWM_SPD_Start(void);                            // Proxy Class 1
extern void PWM_SPD_Stop(void);                             // Proxy Class 1
extern BYTE PWM_SPD_bReadCounter(void);                     // Proxy Class 2
extern void PWM_SPD_WritePeriod(BYTE bPeriod);              // Proxy Class 1
extern BYTE PWM_SPD_bReadPulseWidth(void);                  // Proxy Class 1
extern void PWM_SPD_WritePulseWidth(BYTE bPulseWidth);      // Proxy Class 1

// The following functions are deprecated.
// They may be omitted in future releases
//
extern BYTE bPWM_SPD_ReadCounter(void);            // Deprecated
extern BYTE bPWM_SPD_ReadPulseWidth(void);         // Deprecated


//--------------------------------------------------
// Constants for PWM_SPD API's.
//--------------------------------------------------

#define PWM_SPD_CONTROL_REG_START_BIT          ( 0x01 )
#define PWM_SPD_INT_REG_ADDR                   ( 0x0e1 )
#define PWM_SPD_INT_MASK                       ( 0x01 )


//--------------------------------------------------
// Constants for PWM_SPD user defined values
//--------------------------------------------------

#define PWM_SPD_PERIOD                         ( 0x00 )
#define PWM_SPD_PULSE_WIDTH                    ( 0x00 )


//-------------------------------------------------
// Register Addresses for PWM_SPD
//-------------------------------------------------

#pragma ioport  PWM_SPD_COUNTER_REG:    0x020              //DR0 Count register
BYTE            PWM_SPD_COUNTER_REG;
#pragma ioport  PWM_SPD_PERIOD_REG: 0x021                  //DR1 Period register
BYTE            PWM_SPD_PERIOD_REG;
#pragma ioport  PWM_SPD_COMPARE_REG:    0x022              //DR2 Compare register
BYTE            PWM_SPD_COMPARE_REG;
#pragma ioport  PWM_SPD_CONTROL_REG:    0x023              //Control register
BYTE            PWM_SPD_CONTROL_REG;
#pragma ioport  PWM_SPD_FUNC_REG:   0x120                  //Function register
BYTE            PWM_SPD_FUNC_REG;
#pragma ioport  PWM_SPD_INPUT_REG:  0x121                  //Input register
BYTE            PWM_SPD_INPUT_REG;
#pragma ioport  PWM_SPD_OUTPUT_REG: 0x122                  //Output register
BYTE            PWM_SPD_OUTPUT_REG;
#pragma ioport  PWM_SPD_INT_REG:       0x0e1               //Interrupt Mask Register
BYTE            PWM_SPD_INT_REG;


//-------------------------------------------------
// PWM_SPD Macro 'Functions'
//-------------------------------------------------

#define PWM_SPD_Start_M \
   PWM_SPD_CONTROL_REG |=  PWM_SPD_CONTROL_REG_START_BIT

#define PWM_SPD_Stop_M  \
   PWM_SPD_CONTROL_REG &= ~PWM_SPD_CONTROL_REG_START_BIT

#define PWM_SPD_EnableInt_M   \
   M8C_EnableIntMask(PWM_SPD_INT_REG, PWM_SPD_INT_MASK)

#define PWM_SPD_DisableInt_M  \
   M8C_DisableIntMask(PWM_SPD_INT_REG, PWM_SPD_INT_MASK)

#endif
// end of file PWM_SPD.h
