;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: PWM_SPD.inc
;;   Version: 2.60, Updated on 2013/5/19 at 10:44:7
;;  Generated by PSoC Designer 5.4.2946
;;
;;  DESCRIPTION: Assembler declarations for the PWM8 user module interface
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for PWM_SPD API's.
;--------------------------------------------------

PWM_SPD_CONTROL_REG_START_BIT:             equ 0x01    ; Control register start bit
PWM_SPD_INT_REG:                           equ 0x0e1
PWM_SPD_INT_MASK:                          equ 0x01


;--------------------------------------------------
; Constants for PWM_SPD user defined values
;--------------------------------------------------

PWM_SPD_PERIOD:                            equ 0x00
PWM_SPD_PULSE_WIDTH:                       equ 0x00


;--------------------------------------------------
; Register Address Constants for PWM_SPD
;--------------------------------------------------

PWM_SPD_COUNTER_REG:                   equ 0x20   ; DR0 Count register
PWM_SPD_PERIOD_REG:                    equ 0x21   ; DR1 Period register
PWM_SPD_COMPARE_REG:                   equ 0x22   ; DR2 Compare register
PWM_SPD_CONTROL_REG:                   equ 0x23   ; Control register
PWM_SPD_FUNC_REG:                      equ 0x20   ; Function register
PWM_SPD_INPUT_REG:                     equ 0x21   ; Input register
PWM_SPD_OUTPUT_REG:                    equ 0x22   ; Output register


;--------------------------------------------------
; PWM_SPD Macro 'Functions'
;--------------------------------------------------

   macro PWM_SPD_Start_M
   or    reg[PWM_SPD_CONTROL_REG],  PWM_SPD_CONTROL_REG_START_BIT
   endm

   macro PWM_SPD_Stop_M
   and   reg[PWM_SPD_CONTROL_REG], ~PWM_SPD_CONTROL_REG_START_BIT
   endm

   macro PWM_SPD_EnableInt_M
   M8C_EnableIntMask PWM_SPD_INT_REG, PWM_SPD_INT_MASK
   endm

   macro PWM_SPD_DisableInt_M
   M8C_DisableIntMask PWM_SPD_INT_REG, PWM_SPD_INT_MASK
   endm


; end of file PWM_SPD.inc
