//*****************************************************************************
//*****************************************************************************
//  FILENAME: RF_RX.h
//   Version: 3.50, Updated on 2013/5/19 at 10:44:10
//  Generated by PSoC Designer 5.4.2946
//
//  DESCRIPTION:  RX8 User Module C Language interface file.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef RF_RX_INCLUDE
#define RF_RX_INCLUDE

// include the global header file
#include <m8c.h>

#define RF_RX_RXBUF_ENABLE 1

//-------------------------------------------------
// Prototypes of the RF_RX API.
//-------------------------------------------------

#if ( RF_RX_RXBUF_ENABLE )
extern char RF_RX_aRxBuffer[];
extern BYTE RF_RX_bRxCnt;
extern BYTE RF_RX_fStatus;
#endif

// Create pragmas to support proper argument and return value passing
#pragma fastcall16  RF_RX_EnableInt
#pragma fastcall16  RF_RX_DisableInt
#pragma fastcall16  RF_RX_Start
#pragma fastcall16  RF_RX_Stop
#pragma fastcall16  RF_RX_bReadRxData
#pragma fastcall16  RF_RX_bReadRxStatus

#pragma fastcall16  RF_RX_cGetChar
#pragma fastcall16  RF_RX_cReadChar
#pragma fastcall16  RF_RX_iReadChar

#if ( RF_RX_RXBUF_ENABLE )
#pragma fastcall16  RF_RX_CmdReset
#pragma fastcall16  RF_RX_bCmdCheck
#pragma fastcall16  RF_RX_bErrCheck
#pragma fastcall16  RF_RX_bCmdLength
#pragma fastcall16  RF_RX_szGetParam
#pragma fastcall16  RF_RX_szGetRestOfParams
#endif

//-------------------------------------------------
// Prototypes of the RF_RX API.
//-------------------------------------------------
extern void  RF_RX_EnableInt(void);
extern void  RF_RX_DisableInt(void);
extern void  RF_RX_Start(BYTE bParity);
extern void  RF_RX_Stop(void);
extern BYTE  RF_RX_bReadRxData(void);
extern BYTE  RF_RX_bReadRxStatus(void);

// High level RX functions
extern CHAR         RF_RX_cGetChar(void);
extern CHAR         RF_RX_cReadChar(void);
extern INT          RF_RX_iReadChar(void);

#if ( RF_RX_RXBUF_ENABLE )
extern void   RF_RX_CmdReset(void);
extern BYTE   RF_RX_bCmdCheck(void);
extern BYTE   RF_RX_bErrCheck(void);
extern BYTE   RF_RX_bCmdLength(void);
extern char * RF_RX_szGetParam(void);
extern char * RF_RX_szGetRestOfParams(void);
#endif

// Old function call names, do not use.
// These names will be removed in a future release.
#pragma fastcall16 bRF_RX_ReadRxData
#pragma fastcall16 bRF_RX_ReadRxStatus
extern BYTE bRF_RX_ReadRxData(void);
extern BYTE bRF_RX_ReadRxStatus(void);

//-------------------------------------------------
// Constants for RF_RX API's.
//-------------------------------------------------

//------------------------------------
// Receiver Interrupt masks
//------------------------------------
#define RF_RX_INT_REG_ADDR                     ( 0x0df )
#define RF_RX_bINT_MASK                        ( 0x04 )

//------------------------------------
// Receiver Parity masks
//------------------------------------
#define  RF_RX_PARITY_NONE         0x00
#define  RF_RX_PARITY_EVEN         0x02
#define  RF_RX_PARITY_ODD          0x06

//------------------------------------
//  Receiver Status Register masks
//------------------------------------
#define  RF_RX_RX_ACTIVE           0x10
#define  RF_RX_RX_COMPLETE         0x08
#define  RF_RX_RX_PARITY_ERROR     0x80
#define  RF_RX_RX_OVERRUN_ERROR    0x40
#define  RF_RX_RX_FRAMING_ERROR    0x20
#define  RF_RX_RX_ERROR            0xE0
#define  RF_RX_RX_NO_ERROR         0xE0         // This symbol is deprecated and will removed in the future

#define  RF_RX_RX_NO_DATA         0x01

#define  RF_RX_RX_BUF_ERROR               0xF0  // Mask for any Rx that may occur.
#define  RF_RX_RX_BUF_OVERRUN             0x10  // This indicates the software buffer has
                                                           // been over run.
#define  RF_RX_RX_BUF_CMDTERM             0x01  // Command terminator has been received.

// Old defines, will be removed in future release
#define  RX8_PARITY_NONE         0x00
#define  RX8_PARITY_EVEN         0x02
#define  RX8_PARITY_ODD          0x06
#define  RX8_RX_ACTIVE           0x10
#define  RX8_RX_COMPLETE         0x08
#define  RX8_RX_PARITY_ERROR     0x80
#define  RX8_RX_OVERRUN_ERROR    0x40
#define  RX8_RX_FRAMING_ERROR    0x20
#define  RX8_RX_NO_ERROR         0xE0

//-------------------------------------------------
// Register Addresses for RF_RX
//-------------------------------------------------
#pragma ioport  RF_RX_CONTROL_REG:  0x04b                  // Control register
BYTE            RF_RX_CONTROL_REG;
#pragma ioport  RF_RX_RX_SHIFT_REG: 0x048                  // RX Shift Register register
BYTE            RF_RX_RX_SHIFT_REG;
#pragma ioport  RF_RX_RX_BUFFER_REG:    0x04a              // RX Buffer Register
BYTE            RF_RX_RX_BUFFER_REG;
#pragma ioport  RF_RX_FUNC_REG: 0x148                      // Function register
BYTE            RF_RX_FUNC_REG;
#pragma ioport  RF_RX_INPUT_REG:    0x149                  // Input register
BYTE            RF_RX_INPUT_REG;
#pragma ioport  RF_RX_OUTPUT_REG:   0x14a                  // Output register
BYTE            RF_RX_OUTPUT_REG;

#endif
// end of file RF_RX.h
