;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: RF_RX.inc
;;   Version: 3.50, Updated on 2013/5/19 at 10:44:10
;;  Generated by PSoC Designer 5.4.2946
;;
;;  DESCRIPTION: Assembler declarations for the RX8 user module interface.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"

;--------------------------------------------------
; Constants for RF_RX API's
;--------------------------------------------------

;mask value for global int reg bit for RX instance
RF_RX_bINT_MASK:        equ 04h
;RX8 interrupt address
RF_RX_INT_REG:          equ 0dfh

RF_RX_RXBUF_ENABLE:                         equ   1

RF_RX_RX_IGNORE_BELOW:                       equ  20h
RF_RX_RX_BUFFER_SIZE:                        equ  10h
RF_RX_CMD_TERM:                              equ  dh
RF_RX_DELIMITER:                             equ  20h

; This equate will be removed in future revisions.
; Do not use.
bRF_RX_INT_MASK:        equ 04h
;------------------------------------
;  RX8 Parity masks
;------------------------------------
RF_RX_PARITY_NONE:           equ   0h
RF_RX_PARITY_EVEN:           equ   2h
RF_RX_PARITY_ODD:            equ   6h

;------------------------------------
;  RX8 Status Register masks
;------------------------------------

RF_RX_RX_ACTIVE:             equ   10h
RF_RX_RX_COMPLETE:           equ   08h
RF_RX_RX_REG_FULL:           equ   08h
RF_RX_RX_PARITY_ERROR:       equ   80h
RF_RX_RX_OVERRUN_ERROR:      equ   40h
RF_RX_RX_FRAMING_ERROR:      equ   20h
RF_RX_RX_ERROR:              equ   E0h
RF_RX_RX_NO_ERROR:           equ   E0h   ; This symbol is deprecated and will removed in the future
RF_RX_RX_ENABLE:             equ   01h

RF_RX_RX_BUF_ERROR:                     equ   F0h  ; Mask for any Rx that may occur.
RF_RX_RX_BUF_OVERRUN:                   equ   10h  ; This indicates the software buffer has
                                                        ; been over run.
RF_RX_RX_BUF_CMDTERM:                   equ   01h  ; Command terminator has been received.

RF_RX_RX_NO_DATA:                       equ   01h
RF_RX_RX_NO_ERROR:                      equ   E0h

; Old equates, will be removed in future release
; Do not use
RX8_PARITY_NONE:           equ   0h
RX8_PARITY_EVEN:           equ   2h
RX8_PARITY_ODD:            equ   6h
RX8_RX_ACTIVE:             equ   10h
RX8_RX_COMPLETE:           equ   08h
RX8_RX_PARITY_ERROR:       equ   80h
RX8_RX_OVERRUN_ERROR:      equ   40h
RX8_RX_FRAMING_ERROR:      equ   20h
RX8_RX_NO_ERROR:           equ   E0h


;--------------------------------------------------
; Register Address Constants for RF_RX
;--------------------------------------------------
RF_RX_CONTROL_REG:  equ 4bh                      ;Control register
RF_RX_RX_SHIFT_REG: equ 48h                      ;RX Shift Register register
RF_RX_RX_BUFFER_REG:    equ 4ah                  ;RX Buffer Register
RF_RX_FUNC_REG: equ 48h                          ;Function register
RF_RX_INPUT_REG:    equ 49h                      ;Input register
RF_RX_OUTPUT_REG:   equ 4ah                      ;Output register

; end of file RF_RX.inc
