//*****************************************************************************
//*****************************************************************************
//  FILENAME:  UART_RF.h
//  Version: 5.3, Updated on 2013/5/19 at 10:44:49
//  Generated by PSoC Designer 5.4.2946
//
//  DESCRIPTION:  UART User Module C Language interface file.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef UART_RF_INCLUDE
#define UART_RF_INCLUDE

// include the global header file
#include <m8c.h>

#define UART_RF_RXBUF_ENABLE 1

//-------------------------------------------------
// Prototypes of the UART_RF API.
//-------------------------------------------------

#if ( UART_RF_RXBUF_ENABLE )
extern char UART_RF_aRxBuffer[];
extern BYTE UART_RF_bRxCnt;
extern BYTE UART_RF_fStatus;
#endif



// Create pragmas to support proper argument and return value passing

#pragma fastcall16  UART_RF_SetTxIntMode
#pragma fastcall16  UART_RF_EnableInt
#pragma fastcall16  UART_RF_DisableInt
#pragma fastcall16  UART_RF_Start
#pragma fastcall16  UART_RF_Stop
#pragma fastcall16  UART_RF_SendData
#pragma fastcall16  UART_RF_bReadTxStatus
#pragma fastcall16  UART_RF_bReadRxData
#pragma fastcall16  UART_RF_bReadRxStatus
#pragma fastcall16  UART_RF_PutSHexByte
#pragma fastcall16  UART_RF_PutSHexInt
#pragma fastcall16  UART_RF_CPutString
#pragma fastcall16  UART_RF_PutString
#pragma fastcall16  UART_RF_PutChar
#pragma fastcall16  UART_RF_Write
#pragma fastcall16  UART_RF_CWrite

#pragma fastcall16  UART_RF_cGetChar
#pragma fastcall16  UART_RF_cReadChar
#pragma fastcall16  UART_RF_iReadChar
#pragma fastcall16  UART_RF_IntCntl
#pragma fastcall16  UART_RF_TxIntMode
#pragma fastcall16  UART_RF_PutCRLF

#if ( UART_RF_RXBUF_ENABLE )
#pragma fastcall16  UART_RF_CmdReset
#pragma fastcall16  UART_RF_bCmdCheck
#pragma fastcall16  UART_RF_bErrCheck
#pragma fastcall16  UART_RF_bCmdLength
#pragma fastcall16  UART_RF_szGetParam
#pragma fastcall16  UART_RF_szGetRestOfParams
#endif

//**************************************************
// Prototypes of UART API.
//**************************************************
extern void  UART_RF_SetTxIntMode(BYTE bTxIntMode);
extern void  UART_RF_EnableInt(void);
extern void  UART_RF_DisableInt(void);
extern void  UART_RF_Start(BYTE bParitySetting);
extern void  UART_RF_Stop(void);
extern void  UART_RF_SendData(BYTE bTxData);
extern BYTE  UART_RF_bReadTxStatus(void);
extern BYTE  UART_RF_bReadRxData(void);
extern BYTE  UART_RF_bReadRxStatus(void);

// High level TX functions
extern void   UART_RF_CPutString(const BYTE * szRomString);
extern void   UART_RF_PutString(BYTE * szRamString);
extern void   UART_RF_PutChar(CHAR cData);
extern void   UART_RF_Write(BYTE * szRamString, BYTE bCount);
extern void   UART_RF_CWrite(const BYTE * szRomString, INT iCount);
extern void   UART_RF_PutSHexByte(BYTE bValue);
extern void   UART_RF_PutSHexInt(INT iValue);
extern void   UART_RF_PutCRLF(void);
extern void   UART_RF_TxIntMode(BYTE bMask);

// High level RX functions
extern CHAR   UART_RF_cGetChar(void);
extern CHAR   UART_RF_cReadChar(void);
extern INT    UART_RF_iReadChar(void);
extern void   UART_RF_IntCntl(BYTE bMask);

#if ( UART_RF_RXBUF_ENABLE )
extern void   UART_RF_CmdReset(void);
extern BYTE   UART_RF_bCmdCheck(void);
extern BYTE   UART_RF_bErrCheck(void);
extern BYTE   UART_RF_bCmdLength(void);
extern BYTE * UART_RF_szGetParam(void);
extern BYTE * UART_RF_szGetRestOfParams(void);
#endif

//-------------------------------------------------
// Defines for UART_RF API's.
//-------------------------------------------------



//------------------------------------
//  Parity masks
//------------------------------------
#define  UART_RF_PARITY_NONE        0x00
#define  UART_RF_PARITY_EVEN        0x02
#define  UART_RF_PARITY_ODD         0x06
//------------------------------------
//  Transmitter Status Register masks
//------------------------------------
#define  UART_RF_TX_COMPLETE        0x20
#define  UART_RF_TX_BUFFER_EMPTY    0x10

//------------------------------------
//  Receiver Status Register masks
//------------------------------------
#define  UART_RF_RX_ACTIVE          0x10
#define  UART_RF_RX_COMPLETE        0x08
#define  UART_RF_RX_REG_FULL        0x08
#define  UART_RF_RX_PARITY_ERROR    0x80
#define  UART_RF_RX_OVERRUN_ERROR   0x40
#define  UART_RF_RX_FRAMING_ERROR   0x20
#define  UART_RF_RX_ERROR           0xE0
#define  UART_RF_RX_NO_ERROR        0xE0          // This symbol is deprecated and will removed in the future

#define  UART_RF_RX_NO_DATA         0x01

#define  UART_RF_RX_BUF_ERROR             0xF0  // Mask for any Rx that may occur.
#define  UART_RF_RX_BUF_OVERRUN           0x10  // This indicates the software buffer has
                                                           // been over run.
#define  UART_RF_RX_BUF_CMDTERM           0x01  // Command terminator has been received.

// Interrupt control used with  UART_RF_IntCntl() function
#define UART_RF_ENABLE_RX_INT  0x01
#define UART_RF_ENABLE_TX_INT  0x02
#define UART_RF_DISABLE_RX_INT 0x00
#define UART_RF_DISABLE_TX_INT 0x00

// Interrupt Modes
#define UART_RF_INT_MODE_TX_REG_EMPTY 0x00
#define UART_RF_INT_MODE_TX_COMPLETE  0x01

//-------------------------------------------------
// Register Address Constants for UART_RF
//-------------------------------------------------

#pragma ioport  UART_RF_TX_CONTROL_REG: 0x04b               // Control register
BYTE            UART_RF_TX_CONTROL_REG;
#pragma ioport  UART_RF_TX_SHIFT_REG:   0x048               // TX Shift Register register
BYTE            UART_RF_TX_SHIFT_REG;
#pragma ioport  UART_RF_TX_BUFFER_REG:  0x049               // TX Buffer Register
BYTE            UART_RF_TX_BUFFER_REG;
#pragma ioport  UART_RF_TX_FUNC_REG:    0x148               // Function register
BYTE            UART_RF_TX_FUNC_REG;
#pragma ioport  UART_RF_TX_INPUT_REG:   0x149               // Input register
BYTE            UART_RF_TX_INPUT_REG;
#pragma ioport  UART_RF_TX_OUTPUT_REG:  0x14a               // Output register
BYTE            UART_RF_TX_OUTPUT_REG;
#pragma ioport  UART_RF_RX_CONTROL_REG: 0x04f               // Control register
BYTE            UART_RF_RX_CONTROL_REG;
#pragma ioport  UART_RF_RX_SHIFT_REG:   0x04c               // RX Shift Register register
BYTE            UART_RF_RX_SHIFT_REG;
#pragma ioport  UART_RF_RX_BUFFER_REG:  0x04e               // RX Buffer Register
BYTE            UART_RF_RX_BUFFER_REG;
#pragma ioport  UART_RF_RX_FUNC_REG:    0x14c               // Function register
BYTE            UART_RF_RX_FUNC_REG;
#pragma ioport  UART_RF_RX_INPUT_REG:   0x14d               // Input register
BYTE            UART_RF_RX_INPUT_REG;
#pragma ioport  UART_RF_RX_OUTPUT_REG:  0x14e               // Output register
BYTE            UART_RF_RX_OUTPUT_REG;

#pragma ioport  UART_RF_TX_INT_REG:       0x0df            // TX Interrupt Mask Register
BYTE            UART_RF_TX_INT_REG;
#pragma ioport  UART_RF_RX_INT_REG:       0x0df            // RX Interrupt Mask Register
BYTE            UART_RF_RX_INT_REG;

// Masks to use with UART_RF_TX_INT_REG and UART_RF_RX_INT_REG Registers
#define UART_RF_TX_INT_MASK         (0x04) // TX Interrupt register Mask
#define UART_RF_RX_INT_MASK         (0x08) // RX Interrupt register Mask


//-------------------------------------------
//       WARNING WARNING WARNING
// The following defines and function prototypes
// are for backwards compatibility only and
// should not be used for new designs.
//-------------------------------------------
#pragma fastcall16  bUART_RF_ReadTxStatus
#pragma fastcall16  bUART_RF_ReadRxData
#pragma fastcall16  bUART_RF_ReadRxStatus
extern BYTE  bUART_RF_ReadTxStatus(void);
extern BYTE  bUART_RF_ReadRxData(void);
extern BYTE  bUART_RF_ReadRxStatus(void);
//------------------------------------
//  Parity masks
//------------------------------------
#define  UART_PARITY_NONE        0x00
#define  UART_PARITY_EVEN        0x02
#define  UART_PARITY_ODD         0x06

//------------------------------------
//  Transmitter Status Register masks
//------------------------------------
#define  UART_TX_COMPLETE        0x20
#define  UART_TX_BUFFER_EMPTY    0x10

//------------------------------------
//  Receiver Status Register masks
//------------------------------------
#define  UART_RX_ACTIVE          0x10
#define  UART_RX_COMPLETE        0x08
#define  UART_RX_PARITY_ERROR    0x80
#define  UART_RX_OVERRUN_ERROR   0x40
#define  UART_RX_FRAMING_ERROR   0x20
#define  UART_RX_NO_ERROR        0xE0

#endif
//-------------------------------------------
//             END WARNING
//-------------------------------------------
// end of file UART_RF.h
