//*****************************************************************************
//*****************************************************************************
//  FILENAME: ADCINC14.h
//  Version: 1.20, Updated on 2013/5/19 at 10:39:54
//	Generated by PSoC Designer 5.4.2946
//
//  DESCRIPTION:  C declarations for theADCINCPWM User Module with
//                a 1st-order modulator.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#ifndef ADCINC14_INCLUDE
#define ADCINC14_INCLUDE

#include <m8c.h>

#pragma fastcall16 ADCINC14_Start
#pragma fastcall16 ADCINC14_SetPower
#pragma fastcall16 ADCINC14_Stop
#pragma fastcall16 ADCINC14_GetSamples
#pragma fastcall16 ADCINC14_StopADC
#pragma fastcall16 ADCINC14_fIsDataAvailable
#pragma fastcall16 ADCINC14_iClearFlagGetData
#pragma fastcall16 ADCINC14_wClearFlagGetData
#pragma fastcall16 ADCINC14_cClearFlagGetData
#pragma fastcall16 ADCINC14_bClearFlagGetData
#pragma fastcall16 ADCINC14_iGetData
#pragma fastcall16 ADCINC14_wGetData
#pragma fastcall16 ADCINC14_cGetData
#pragma fastcall16 ADCINC14_bGetData
#pragma fastcall16 ADCINC14_fClearFlag
#pragma fastcall16 ADCINC14_WritePulseWidth

//-------------------------------------------------
// Prototypes of the ADCINC14 API.
//-------------------------------------------------
extern void  ADCINC14_Start(BYTE bPower);
extern void  ADCINC14_SetPower(BYTE bPower);
extern void  ADCINC14_Stop(void);
extern void  ADCINC14_GetSamples(BYTE bNumSamples);
extern void  ADCINC14_StopADC(void);
extern BYTE  ADCINC14_fIsDataAvailable(void);
extern INT   ADCINC14_iClearFlagGetData(void);
extern WORD  ADCINC14_wClearFlagGetData(void);
extern CHAR  ADCINC14_cClearFlagGetData(void);
extern BYTE  ADCINC14_bClearFlagGetData(void);
extern INT   ADCINC14_iGetData(void);
extern WORD  ADCINC14_wGetData(void);
extern CHAR  ADCINC14_cGetData(void);
extern BYTE  ADCINC14_bGetData(void);
extern BYTE  ADCINC14_fClearFlag(void);
extern void  ADCINC14_WritePulseWidth(BYTE bPulseWidthValue);


//-------------------------------------------------
// Defines for ADCINC14 API's.
//-------------------------------------------------
#define ADCINC14_OFF         0
#define ADCINC14_LOWPOWER    1
#define ADCINC14_MEDPOWER    2
#define ADCINC14_HIGHPOWER   3


//-------------------------------------------------
// Hardware Register Definitions
//-------------------------------------------------
#pragma ioport  ADCINC14_PWMdr0:    0x024                 //Period reg
BYTE            ADCINC14_PWMdr0;
#pragma ioport  ADCINC14_PWMdr1:    0x025                 //1_ADDRh   ; Down count reg
BYTE            ADCINC14_PWMdr1;               
#pragma ioport  ADCINC14_PWMdr2:    0x026                 //Compare reg
BYTE            ADCINC14_PWMdr2;
#pragma ioport  ADCINC14_PWMcr0:    0x027                 //Control reg
BYTE            ADCINC14_PWMcr0;
#pragma ioport  ADCINC14_PWMfn: 0x124                  //Function reg
BYTE            ADCINC14_PWMfn;
#pragma ioport  ADCINC14_PWMsl: 0x125                  //Input select reg
BYTE            ADCINC14_PWMsl;
#pragma ioport  ADCINC14_PWMos: 0x126                  //Output select reg
BYTE            ADCINC14_PWMos;
#pragma ioport  ADCINC14_AtoD1cr0:  0x080              //Analog block 1 control register 0
BYTE            ADCINC14_AtoD1cr0;
#pragma ioport  ADCINC14_AtoD1cr1:  0x081              //Analog block 1 control register 1
BYTE            ADCINC14_AtoD1cr1;
#pragma ioport  ADCINC14_AtoD1cr2:  0x082              //Analog block 1 control register 2
BYTE            ADCINC14_AtoD1cr2;
#pragma ioport  ADCINC14_AtoD1cr3:  0x083              //Analog block 1 control register 3
BYTE            ADCINC14_AtoD1cr3;
#pragma ioport  ADCINC14_AtoD2cr0:  0x090              //Analog block 2 control register 0
BYTE            ADCINC14_AtoD2cr0;
#pragma ioport  ADCINC14_AtoD2cr1:  0x091              //Analog block 2 control register 1
BYTE            ADCINC14_AtoD2cr1;
#pragma ioport  ADCINC14_AtoD2cr2:  0x092              //Analog block 2 control register 2
BYTE            ADCINC14_AtoD2cr2;
#pragma ioport  ADCINC14_AtoD2cr3:  0x093              //Analog block 2 control register 3
BYTE            ADCINC14_AtoD2cr3;

#endif
// end of file ADCINC14.h
