;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME:   UART_RF.inc
;;  Version: 5.3, Updated on 2013/5/19 at 10:44:49
;;  Generated by PSoC Designer 5.4.2946
;;
;;  DESCRIPTION:  Assembler declarations for the UART user module.
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress Semiconductor 2013. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

;--------------------------------------------------
; Constants for UART_RF API's
;--------------------------------------------------

;mask value for global int reg bit for TX instance
UART_RF_TX_INT_MASK:                         equ 0x04
UART_RF_TX_INT_REG:                          equ 0x0df  ;TX interrupt address
UART_RF_RX_INT_MASK:                         equ 0x08  ;mask value for global int reg bit for RX instance
UART_RF_RX_INT_REG:                          equ 0x0df  ;RX interrupt address

UART_RF_RXBUF_ENABLE:                        equ 1

; Interrupt control masks
UART_RF_ENABLE_RX_INT:                       equ 0x01
UART_RF_DISABLE_RX_INT:                      equ 0x00
UART_RF_ENABLE_TX_INT:                       equ 0x02
UART_RF_DISABLE_TX_INT:                      equ 0x00

UART_RF_INT_MODE_TX_REG_EMPTY:               equ 0x00
UART_RF_INT_MODE_TX_COMPLETE:                equ 0x01

UART_RF_RX_IGNORE_BELOW:                     equ 0x20
UART_RF_RX_BUFFER_SIZE:                      equ 0x11
UART_RF_CMD_TERM:                            equ 0xd
UART_RF_DELIMITER:                           equ 0x20
UART_RF_BACKSPACE_ENABLE:                    equ 0x0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;       WARNING WARNING WARNING
; The following equates are for backwards
; compatibility only and should not be used
; for new designs.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;------------------------------------
;  Parity masks
;------------------------------------
UART_PARITY_NONE:       equ   00h
UART_PARITY_EVEN:       equ   02h
UART_PARITY_ODD:        equ   06h

;------------------------------------
;  TX Status Register masks
;------------------------------------
UART_TX_COMPLETE:       equ   20h
UART_TX_BUFFER_EMPTY:   equ   10h

;------------------------------------
;  RX Status Register masks
;------------------------------------
UART_RX_ACTIVE:         equ   10h
UART_RX_COMPLETE:       equ   08h
UART_RX_PARITY_ERROR:   equ   80h
UART_RX_OVERRUN_ERROR:  equ   40h
UART_RX_FRAMING_ERROR:  equ   20h
UART_RX_NO_ERROR:       equ   E0h
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;             END WARNING
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;------------------------------------
;  Parity masks
;------------------------------------
UART_RF_PARITY_NONE:                    equ   00h
UART_RF_PARITY_EVEN:                    equ   02h
UART_RF_PARITY_ODD:                     equ   06h

;------------------------------------
;  TX Status Register masks
;------------------------------------
UART_RF_TX_COMPLETE:                    equ   20h
UART_RF_TX_BUFFER_EMPTY:                equ   10h

;------------------------------------
;  RX Status Register masks
;------------------------------------
UART_RF_RX_ACTIVE:                      equ   10h
UART_RF_RX_COMPLETE:                    equ   08h
UART_RF_RX_REG_FULL:                    equ   08h
UART_RF_RX_PARITY_ERROR:                equ   80h
UART_RF_RX_OVERRUN_ERROR:               equ   40h
UART_RF_RX_FRAMING_ERROR:               equ   20h
UART_RF_RX_ERROR:                       equ   E0h
UART_RF_RX_ENABLE:                      equ   01h

UART_RF_RX_BUF_ERROR:                   equ   F0h  ; Mask for any Rx that may occur.
UART_RF_RX_BUF_OVERRUN:                 equ   10h  ; This indicates the software buffer has
                                                        ; been over run.
UART_RF_RX_BUF_CMDTERM:                 equ   01h  ; Command terminator has been received.

UART_RF_RX_NO_DATA:                     equ   01h
UART_RF_RX_NO_ERROR:                    equ   E0h


;--------------------------------------------------
; Registers Address Constants for UART_RF
;--------------------------------------------------
;---------------------------------
;  Registers used by TX
;---------------------------------
UART_RF_TX_CONTROL_REG: equ 4bh            ; Control register
UART_RF_TX_SHIFT_REG:   equ 48h               ; TX Shift Register register
UART_RF_TX_BUFFER_REG:  equ 49h               ; TX Buffer Register
UART_RF_TX_FUNC_REG:    equ 48h         ; Function register
UART_RF_TX_INPUT_REG:   equ 49h            ; Input register
UART_RF_TX_OUTPUT_REG:  equ 4ah           ; Output register

;---------------------------------
;  Registers used by RX
;---------------------------------
UART_RF_RX_CONTROL_REG: equ 4fh            ; Control register
UART_RF_RX_SHIFT_REG:   equ 4ch               ; RX Shift Register register
UART_RF_RX_BUFFER_REG:  equ 4eh               ; RX Buffer Register
UART_RF_RX_FUNC_REG:    equ 4ch         ; Function register
UART_RF_RX_INPUT_REG:   equ 4dh            ; Input register
UART_RF_RX_OUTPUT_REG:  equ 4eh           ; Output register

; end of file UART_RF.inc
